#!/bin/bash

#
# Prepare CASA and Pipeline
#
# The script downloads a requiested version of the CASA validation
# distribution and the Pipeline. Optionally a specific Pipeline commit
# is automatically checked out.

#
# Start always with the system default imports


#
# Define location where casa and the pipeline will live
#

# Default BASE_DIR and PATH
BASE_DIR=${HOME}
PATH_SYS=${PATH}
PYTHONPATH_SYS=${PYTHONPATH}

# Default CASA path
CASA_DIR="${BASE_DIR}/casa"

# Default Pipeline path
PIPE_DIR="${BASE_DIR}/pipeline_src"

#
# Define URL location for CASA distribution and Pipeline repository
#
CASA_URL="https://casa.nrao.edu/download/distro/casa/releaseprep"
PIPE_URL="https://open-bitbucket.nrao.edu/scm/pipe/pipeline.git"

#
# Default versions
#
# TODO: querry CASA_URL and find out which is the latest file
CASA_VER=17
CASA_NAM=""
PIPE_COM="latest"
# Don't build pipeline by default
PIPE_BLD=0

while getopts c:n:p:b: option
do
    case "${option}"
    in
	c) CASA_VER=${OPTARG};;
	n) CASA_NAM=${OPTARG};;
	p) PIPE_COM=${OPTARG};;
	b) PIPE_BLD=${OPTARG};;
    esac
done

# CASA archive file name
#
if [ ${CASA_NAM} != "" ]; then
   CASA_ARCHIVE=${CASA_NAM}
else 
   CASA_ARCHIVE="casa-pipeline-validation-"${CASA_VER}
fi

#
# Check / create directories
#

# Create CASA_DIR and PIPE_DIR if does not exist
#
if [ ! -d "${CASA_DIR}" ]; then
    printf "WARN: ${CASA_DIR} doesn't exist, creating it...\n"
    mkdir -p "${CASA_DIR}"
fi
cd ${CASA_DIR}

# Download archive if doesn't exist
#
if [ -f "${CASA_DIR}/${CASA_ARCHIVE}.tar.xz" ]; then
    printf "INFO: ${CASA_ARCHIVE}.tar.xz already exists locally.\n"
else
    curl "${CASA_URL}/${CASA_ARCHIVE}.tar.xz" --remote-name
fi

# Get MD5 checksum file and validate file
#
curl "${CASA_URL}/${CASA_ARCHIVE}.tar.xz.md5" --silent --remote-name
# TODO: MD5 sum shoud be checked
#md5sum --check "${CASA_URL}/${CASA_ARCHIV}.tar.xz.md5"

# Untar file
#
if [ ! -d "${CASA_DIR}/${CASA_ARCHIVE}" ]; then
    printf "INFO: Extracting archive ${CASA_ARCHIVE}.tar.xz...\n"
    tar -x -f "${CASA_DIR}/${CASA_ARCHIVE}.tar.xz"
else
    printf "WARN: ${CASA_ARCHIVE} already exists (hopefully unchanged)!\n"
fi

#
# Define PATH_CASA and add it to current session PATH
PATH_CASA="${CASA_DIR}/${CASA_ARCHIVE}:${CASA_DIR}/${CASA_ARCHIVE}/bin"
PATH=${PATH_CASA}:${PATH}

#
# Clone the Pipeline and check out the requested commit
#

if [ ! -d "${PIPE_DIR}" ]; then
    printf "WARN: ${PIPE_DIR} doesn't exist, creating it...\n"
    mkdir -p "${PIPE_DIR}"
fi
cd ${PIPE_DIR}

printf "INFO: Cloning Pipeline from ${PIPE_URL}\n"
git clone ${PIPE_URL} -q

# Rename Pipeline folder to commit ID
#
if [ -d "${PIPE_COM}" ]; then
    # TODO should ask user
    printf "WARN: removing existing folder ${PIPE_DIR}/${PIPE_COM}\n"
    rm -rf "${PIPE_DIR}/${PIPE_COM}"
fi
mv pipeline ${PIPE_COM}
cd ${PIPE_COM}

# Checkout requested commit
if [ ${PIPE_COM} != "latest" ]; then
    printf "Checking commit ${PIPE_COM} out...\n"
    git checkout ${PIPE_COM} -q
fi

#
# Build pipeline if asked for...
printf "# Pipeline build log generated on $(date +'%T %d.%m.%y')\n\n" > ${BASE_DIR}/_pipeline_build_log
if [ ${PIPE_BLD} -eq 1 ]; then
    printf "INFO: Building Pipeline fully...\n"
    python3 setup.py build >> ${BASE_DIR}/_pipeline_build_log
    PATH_PIPE="${PIPE_DIR}/${PIPE_COM}/build/lib"
# ... or link source path build only cli tasks
else
    printf "INFO: Linking Pipeline source and building tasks...\n"
    python3 setup.py buildmytasks -i >> ${BASE_DIR}/_pipeline_build_log
    PATH_PIPE="${PIPE_DIR}/${PIPE_COM}"
fi

# Add Pipeline to PYTHONPATH
export PYTHONPATH=${PATH_PIPE}:${PYTHONPATH_SYS}

#
# Set environment variables
#
# This is tricky: let's create a dot file with the relevant exports
# and then source it.
#
cd ${BASE_DIR}

# Script to restore original PATH
printf "
# This is a file generated by build_casa_pipe.sh\n
# source this file to restore PATH environment variable\n
export PATH=${PATH_SYS}\n
export PYTHONPATH=${PYTHONPATH_SYS}" > .bash_restore_path

# New PATH
printf "
# This is a file generated by build_casa_pipe.sh
# source this file to add casa and pipeline to PATH env. variable\n
export PATH=${PATH_CASA}:${PATH_SYS}
export PYTHONPATH=${PATH_PIPE}:${PYTHONPATH_SYS}" > .bash_casa_pipe_path

printf "\nsource ${BASE_DIR}/.bash_casa_pipe_path\n\n"
